﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Text;
using ICSharpCode.SharpZipLib.Zip;
using System.Data.SqlClient;
using System.Text.RegularExpressions;

public partial class BitrixDeploy : System.Web.UI.Page
{
	StringBuilder sb = new StringBuilder();
	void RemoveDirectory(string path, bool delete)
	{
		foreach (string sub in Directory.GetDirectories(path))
			Directory.Delete(sub, true);
		foreach (string file in Directory.GetFiles(path))
			File.Delete(file);
		if (delete)
			Directory.Delete(path);
	}
	protected void Page_Load(object sender, EventArgs e)
	{
		if (!IsPostBack && Request["ok"] != null)
			Success.Visible = true;
	}
	protected void Extract_Click(object sender, EventArgs e)
	{
		try
		{
			string source = MapPath(Source.Text);
			string target = MapPath(Target.Text);
			FastZip zip = new FastZip();
			zip.ExtractZip(source, target, null);
			Response.Redirect("BitrixDeploy.aspx?ok=");
		}
		catch (Exception ex)
		{
			sb.AppendLine(ex.ToString());
			Error.Text = "<div style=\"overflow: auto\" ><pre>" + HttpUtility.HtmlEncode(sb.ToString()) + "</pre></div>";
			Error.Visible = true;
		}
	}

	protected void Clean_Click(object sender, EventArgs e)
	{
		try
		{
			string dir = MapPath(DeleteDirectory.Text);
			RemoveDirectory(dir, false);
			Success.Visible = true;
		}
		catch (Exception ex)
		{
			sb.AppendLine(ex.ToString());
			Error.Text = "<div style=\"overflow: auto\" ><pre>" + HttpUtility.HtmlEncode(sb.ToString()) + "</pre></div>";
			Error.Visible = true;
		}
	}
	protected void Test_Click(object sender, EventArgs e)
	{
		try
		{
			string connectionString = BuildConnectionString();
			using (SqlConnection connection = new SqlConnection(connectionString))
				connection.Open();
			Success.Visible = true;
		}
		catch (Exception ex)
		{
			sb.AppendLine(ex.ToString());
			Error.Text = "<div style=\"overflow: auto\" ><pre>" + HttpUtility.HtmlEncode(sb.ToString()) + "</pre></div>";
			Error.Visible = true;
		}
	}

	private string BuildConnectionString()
	{
		SqlConnectionStringBuilder sql = new SqlConnectionStringBuilder();
		sql.DataSource = SqlServer.Text;
		sql.IntegratedSecurity = false;
		sql.UserID = User.Text;
		sql.Password = Password.Text;
		sql.InitialCatalog = Database.Text;
		return sql.ToString();
	}

	IEnumerable<SqlCommand> ExtractSqlCommands(string text, SqlConnection connection)
	{
		Regex regex = new Regex(@"^GO\b", RegexOptions.Multiline | RegexOptions.IgnoreCase);
		string[] strArray = regex.Split(text);
		foreach (string str in strArray)
			yield return new SqlCommand(str, connection);
	}

	protected void ExecuteUpload_Click(object sender, EventArgs e)
	{
		try
		{
			if (!UploadSqlFile.HasFile)
				return;
			string connectionString = BuildConnectionString();
			using (SqlConnection connection = new SqlConnection(connectionString))
			{
				string commandText;
				using (StreamReader reader = new StreamReader(UploadSqlFile.FileContent))
					commandText = reader.ReadToEnd();
				connection.Open();
				foreach (SqlCommand command in ExtractSqlCommands(commandText, connection))
					using (command)
						command.ExecuteNonQuery();
			}
			Success.Visible = true;
		}
		catch (Exception ex)
		{
			sb.AppendLine(ex.ToString());
			Error.Text = "<div style=\"overflow: auto\" ><pre>" + HttpUtility.HtmlEncode(sb.ToString()) + "</pre></div>";
			Error.Visible = true;
		}
	}
	protected void Remove_Click(object sender, EventArgs e)
	{
		try
		{
			File.Delete(MapPath("~/BitrixDeploy.aspx"));
			File.Delete(MapPath("~/BitrixDeploy.aspx.cs"));
			try
			{
				File.Delete(MapPath("~/Bin/ICSharpCode.SharpZipLib.dll"));
				Directory.Delete(MapPath("~/Bin"));
			}
			catch
			{
			}
			Success.Visible = true;
		}
		catch (Exception ex)
		{
			sb.AppendLine(ex.ToString());
			Error.Text = "<div style=\"overflow: auto\" ><pre>" + HttpUtility.HtmlEncode(sb.ToString()) + "</pre></div>";
			Error.Visible = true;
		}
	}
	protected void ExecuteOpen_Click(object sender, EventArgs e)
	{
		try
		{
			string connectionString = BuildConnectionString();
			using (SqlConnection connection = new SqlConnection(connectionString))
			{
				string commandText = File.ReadAllText(MapPath(OpenSqlFile.Text));
				connection.Open();
				foreach (SqlCommand command in ExtractSqlCommands(commandText, connection))
					using (command)
						command.ExecuteNonQuery();
			}
			Success.Visible = true;
		}
		catch (Exception ex)
		{
			sb.AppendLine(ex.ToString());
			Error.Text = "<div style=\"overflow: auto\" ><pre>" + HttpUtility.HtmlEncode(sb.ToString()) + "</pre></div>";
			Error.Visible = true;
		}
	}
}
